/*Matrix Animation - a scrolling list of random characters, like the popular screensavers
Copyright (C) 2006  Peter Fernandes

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.*/

#include <tigcclib.h>

//scrolls the screen contents from y==1 to y=108 up one line
void scroll_v(void) {
	unsigned short *pos=LCD_MEM+30; //Our pointer to the second row of pixels
	short i=9; //10 shorts to span the 89's LCD
	short v=1; //our height loop var

	for(v=1;v<108;v++) { //loop from the second row to the bottom of where the text is drawn
		for(i=9;i>=0;i--)
				*(pos+i-15)=*(pos+i); //copy each segment to the line above
		pos+=15; //increment our pointer's address to the next line
	}
	
}

// Main Function
void _main(void)
{
	short i=0; //number of characters written on the line already
	short scroll=0;

	//redirect AUTO_INT's 1 and 5 so they don't interfere with _keytest
	INT_HANDLER save_int_1;
	INT_HANDLER save_int_5;

	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_5, DUMMY_HANDLER);



	randomize(); //seed the random number generator

	do {
		if(scroll>=7) {	//if we have scrolled the height of an entire character
			for(i=0;i<26;i++)
				//for each of the 26 spaces in the current row, draw a random char
				printf_xy(i*6,100,"%c",random(256));
			scroll=0;
		}

		scroll_v();
		scroll++;
	} while(!_keytest(RR_ESC));

	//restore interrupts, as we tend not to like crashes, and non-responsive AMS :)
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5, save_int_5);
}
